#ifndef __jfauderrs_h__
#define __jfauderrs_h__

typedef enum {
	// NON-FATAL ERRORS
	jfauderr_noerror = 0,
	jfauderr_ok = 0,
	
	jfauderr_genericerror = 1,

	jfauderr_alreadyinited,
	jfauderr_notimpl,

	// file readers
	jfauderr_disabled,
	jfauderr_openerror,

	// file type recognition
	jfauderr_notrecognised,
	jfauderr_notcompatible,
	jfauderr_filedamaged,

	// buffers
	jfauderr_notloaded,
	jfauderr_notprepared,
	jfauderr_buffull,

	// channels
	jfauderr_badhandle,
	jfauderr_nofreechans,

	// FATAL ERRORS
	jfauderr_outofmemory = -1,
	jfauderr_deverror    = -2,
	jfauderr_ioerror     = -3,
	jfauderr_notinited   = -4,

	// file reader initialisation
	jfauderr_initfailed  = -5

} jfauderr;

// errors that should cause the program to give up and die are recognised by this
#define JFAUDERR_FATAL(x) ((x)<jfauderr_ok)

const char *JFAud_errstr(jfauderr err);

#endif
