#ifndef __midiseq_h__
#define __midiseq_h__

jfauderr midifile_loadfile(MidiBuffer *midi, File *fh);

typedef struct {
	unsigned long delta;
	unsigned char const *evtptr;
	unsigned char command;
	unsigned long evtlen;
	short loopcount;	// loop repeat counter (-1 = infinite)
	unsigned long loopstart, loopend;

	unsigned char *trackpos, trackflags;
} MidiSequencerTrackdef;

typedef struct {
	MidiBuffer *midifile;

	MidiSequencerTrackdef *seqtrack;
	unsigned char lastcommand;
	int infiniteloop;

	unsigned char evtbuf[4];	// temporary buffer for synthesised events

	unsigned curtrack;
} MidiSequencer;

enum {
        midiseqdev_genmidi = 0,	// general midi
	midiseqdev_sc,		// roland sound canvas
	midiseqdev_sbemu,	// sound blaster emu8k (AWE cards)
	midiseqdev_waveb,	// wave blaster
	midiseqdev_sbopl,	// sound blaster fm synth (opl2,3)
	midiseqdev_mvpa,	// media vision pro audio
	midiseqdev_sm16,	// logitech sound man 16
	midiseqdev_adlib,	// adlib
	midiseqdev_sscape,	// esoniq soundscape
	midiseqdev_gus,		// gravis ultrasound
	midiseqdev_ALL = 127
};

jfauderr midiseq_new(MidiSequencer *seq, MidiBuffer *midi);
jfauderr midiseq_free(MidiSequencer *seq);
jfauderr midiseq_setdevice(MidiSequencer *seq, int dev);
jfauderr midiseq_setloop(MidiSequencer *seq, int loop);
int midiseq_getevent(MidiSequencer *seq, unsigned *delta, unsigned char *command, unsigned *len, unsigned char const **evtdata);

#endif

