
// Winlayer2.c

// At Winlayer.c - line 136
// #include "winlayer2.c"
// Added -z for build play             wxbl
//

#define FIELDSWIDE 366
#define PADWIDE 5		// 5 units of padding

static HWND startupdlg = NULL;
static long startupdlgsaferect[4] = { -1,-1,-1,-1 };
static int  startupdlgcommand = 0;
static void (*startupdlgonclose)(void) = NULL;

// startup_dlgproc() -- dialog procedure for the initialisation dialog

static INT_PTR CALLBACK startup_dlgproc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static HBITMAP hbmp = NULL;
	RECT rdlg, rbmp, rtxt;
	HDC hdc;
	int height=5;

	switch (uMsg) {
		case WM_INITDIALOG:
			// set the bitmap
			hbmp = LoadBitmap(hInstance, MAKEINTRESOURCE(WIN_STARTWINBMP));
			SendDlgItemMessage(hwndDlg, WIN_STARTWIN_ITEMBITMAP, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hbmp);

			// fetch the adjusted size
			GetClientRect(GetDlgItem(hwndDlg,WIN_STARTWIN_ITEMBITMAP), &rbmp);
			rbmp.right++; rbmp.bottom++;

			// move the bitmap to the top of the client area
			MoveWindow(GetDlgItem(hwndDlg,WIN_STARTWIN_ITEMBITMAP),
					0,0, rbmp.right,rbmp.bottom,
					FALSE);

			rdlg.left = 0;
			rdlg.top = 0;
			rdlg.right = rbmp.right; //+PADWIDE+FIELDSWIDE+PADWIDE;
			rdlg.bottom = rbmp.bottom;

			AdjustWindowRect(&rdlg,
					GetWindowLong(hwndDlg, GWL_STYLE),
					FALSE);

			rdlg.right -= rdlg.left;
			rdlg.bottom -= rdlg.top;

			hdc = GetDC(NULL);
			rdlg.left = (GetDeviceCaps(hdc, HORZRES) - rdlg.right) / 2;
			rdlg.top = (GetDeviceCaps(hdc, VERTRES) - rdlg.bottom) / 2;
			ReleaseDC(NULL, hdc);

			SetWindowPos(hwndDlg,NULL,
					rdlg.left,rdlg.top,
					rdlg.right,rdlg.bottom,
					SWP_NOREPOSITION);

			// save the safe region of the window
			startupdlgsaferect[0] = rbmp.right;		// left
			startupdlgsaferect[1] = 0;			// top
			startupdlgsaferect[2] = PADWIDE+FIELDSWIDE+PADWIDE;	// width
			startupdlgsaferect[3] = rbmp.bottom;		// height

			return TRUE;

		case WM_CLOSE:
			quitevent = 1;
			return TRUE;

		case WM_DESTROY:
			if (hbmp) {
				DeleteObject(hbmp);
				hbmp = NULL;
			}

			if (startupdlgonclose) startupdlgonclose();

			startupdlg = NULL;
			return TRUE;

		case WM_COMMAND:
			startupdlgcommand = LOWORD(wParam);
			return FALSE;
/*
		case WM_CTLCOLORSTATIC:
			switch (GetDlgCtrlID((HWND)lParam))
			{
				case WIN_STARTWIN_ITEMLIST:
					return (BOOL)GetSysColorBrush(COLOR_WINDOW);
				default: break;
			}
			break;
*/
		default: break;
	}

	return FALSE;
}

int startwin_settitle(const char *str)
{
	if (!startupdlg) return 1;
	SetWindowText(startupdlg, str);
	return 0;
}

int startwin_open(void)
{
    char *cmdbuf = NULL;                                             // wxbl
    cmdbuf = strdup(GetCommandLine());
    if (Bstrncasecmp(cmdbuf, "Swp.exe -z", 10) == 0)
        return 0;

	if (startupdlg) return 1;
	startupdlg = CreateDialog((HINSTANCE)win_gethinstance(), MAKEINTRESOURCE(WIN_STARTWIN), NULL, startup_dlgproc);
	if (startupdlg)
		return 0;
	return -1;
}

int startwin_close(void)
{
	if (!startupdlg) return 1;
	DestroyWindow(startupdlg);
	startupdlg = NULL;
	return 0;
}

int startwin_puts(const char *buf)
{
	if (!startupdlg) return 1;
	return 0;
}

int startwin_idle(void *v)
{
	if (!startupdlg || !IsWindow(startupdlg)) return 0;
	if (IsDialogMessage(startupdlg, (MSG*)v)) return 1;
	return 0;
}
/*
int startwin_run(void)
{
	MSG msg;
	if (!startupdlg) return 1;

	done = -1;

	SetPage(TAB_CONFIG);
	EnableConfig(1);

	settings.fullscreen = fullscreen;
	settings.xdim2d = xdim2d;
	settings.ydim2d = ydim2d;
	settings.xdim3d = xdimgame;
	settings.ydim3d = ydimgame;
	settings.bpp3d = bppgame;
	settings.forcesetup = forcesetup;
	PopulateForm();

	while (done < 0) {
		switch (GetMessage(&msg, NULL, 0,0)) {
			case 0: done = 1; break;
			case -1: return -1;
			default:
				 if (IsWindow(startupdlg) && IsDialogMessage(startupdlg, &msg)) break;
				 TranslateMessage(&msg);
				 DispatchMessage(&msg);
				 break;
		}
	}

	SetPage(TAB_MESSAGES);
	EnableConfig(0);
	if (done) {
		fullscreen = settings.fullscreen;
		xdim2d = settings.xdim2d;
		ydim2d = settings.ydim2d;
		xdimgame = settings.xdim3d;
		ydimgame = settings.ydim3d;
		bppgame = settings.bpp3d;
		forcesetup = settings.forcesetup;
	}

	return done;
}
*/
